# Author:: David J Felix
# Copyright:: Copyright (c) 2015 David J Felix
# License:: MIT

class git(
  $git_url='https://github.com/msysgit/msysgit/releases/download/Git-1.9.5-preview20141217/Git-1.9.5-preview20141217.exe',
  $destination_directory='C:\ProgramData\PuppetLabs\puppet\etc',
  $destination_file='git.exe',
  $proxy_address='',
  $proxy_user='',
  $proxy_password='',
  $is_password_secure=false
) {
  case $::osfamily {
    'Windows': {
      download_file { 'git.exe':
        url                   => $git_url,
        destination_directory => $destination_directory,
        destination_file      => $destination_file,
        proxy_address         => $proxy_address,
        proxy_user            => $proxy_user,
        proxy_password        => $proxy_password,
        is_password_secure    => $is_password_secure 
      }
      package { 'git.exe':
        ensure          => installed,
        source          => "${destination_directory}\\${destination_file}",
        install_options => ['/VERYSILENT'],
        require         => Download_file['git.exe']
      }
    }
    'Debian', 'Redhat': {
      #FIXME: add debian support here
      package { 'git':
        ensure => installed,
      }
    }
    default: {
      fail("Unsupported osfamily: ${::osfamily}")
    }
  }
}
